(* Title:  BaseDefinitions/celem-91.sml
   Author: Walther Neuper
   (c) due to copyright terms

Check entries to Know_Store unique.
This is legacy code; check runs on #guh using check_unique

"guh" stands for "globally unique handle" -- over all of the internet,
the last remaining code from Klaus Schmaranz's Dinopolis Project.
*)

(* switch for checking guhs unique before storing a pbl or met;
   set true at startup (done at begin of ROOT.ML)
   set false for editing Isac_Knowledge (done at end of ROOT.ML).
   Must be global for re-use in other structs *)
val check_unique = Attrib.setup_config_bool \<^binding>\<open>check_unique\<close> (K true);

signature CHECK_UNIQUE =
sig
  type id
  val collect: ('a -> 'b) -> 'a Store.T -> 'b list;
  val message: ('a -> id list) -> id -> 'a -> unit;
end

(**)
structure Check_Unique(**): CHECK_UNIQUE(**) =
struct
(**)

type id = string;

fun collect select_guh pbls =
  let
    fun node coll (Store.Node (_, [n], ns)) = [select_guh n] @ (nodes coll ns)
      | node _ _ = raise ERROR "collect_guhs: too general Store.Node"
	  and nodes coll [] = coll
      | nodes coll (n :: ns) = (node coll n) @ (nodes coll ns);
  in nodes [] pbls end;

fun message select id store =
  if member op = (select store) id
  then raise ERROR ("Check_Unique failed with \"" ^ id ^ "\";\n" ^
	      "use \"sort_guhs()\" for a list of guhs;\n" ^
	      "consider setting \"Config.put check_unique false @{context}\"")
  else ();

(**)end(**)
