(* Title:  "Minisubpbl/100a-init-rootpbl-Maximum.sml"
   Author: Walther Neuper 1105
   (c) copyright due to lincense terms.

COMPARE Specify/specify.sml --- specify-phase: low level functions ---

ATTENTION: the file creates buffer overflow if copied in one piece !

Note: This test --- steps into me --- more than once, to a somewhat extreme extent;
  in order not to get lost while working in Test_Some etc, 
  re-introduce  ML (*--- step into XXXXX ---*) and Co.
  and use Sidekick for orientation.
  Nesting is indicated by  /---   //--   ///-  at the left margin of the comments.
*)
(*/------- these overwrite definitions in section above ---\*)
open Ctree;
open Pos;
open TermC;
open Istate;
open Tactic;
open I_Model;
open P_Model
open Rewrite;
open Step;
open LItool;
open LI;
open Test_Code
open Specify
open ME_Misc
open Pre_Conds;
(*\------- these overwrite definitions in section above ---/*)

val (_(*example text*),
  (model as ("Constants [r = (7::real)]" :: "Maximum A" :: "AdditionalValues [u, v]" :: 
     "Extremum (A = 2 * u * v - u \<up> 2)" :: 
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" :: 
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" :: 
     "SideConditions [(u::real) / 2 = r * sin \<alpha>, 2 / v = r * cos \<alpha>]" ::
(*---------------------------------------------,(v::real) / 2 = r * cos \<alpha>]" --- ERROR in example*)
     "FunctionVariable a" :: "FunctionVariable b" :: "FunctionVariable \<alpha>" :: 
     "Domain {0 <..< r}" :: "Domain {0 <..< r}" :: "Domain {0 <..< \<pi> / 2}" ::
     "ErrorBound (\<epsilon> = (0::real))" :: []), 
   refs as ("Diff_App", 
     ["univariate_calculus", "Optimisation"],
     ["Optimisation", "by_univariate_calculus"])))
  = Store.get (Know_Store.get_expls @{theory}) ["Diff_App-No.123a"] ["Diff_App-No.123a"];

val c = [];
val return_init_calc = 
 Test_Code.init_calc @{context} [(model, refs)]; (*val Model_Problem = nxt;*)
(*/------------------- step into init_calc -------------------------------------------------\\*)
"~~~~~ fun init_calc , args:"; val (ctxt, [(model, refs as (thy_id, _, _))]) =
  (@{context}, [(model, refs)]);
    val thy = thy_id |> ThyC.get_theory ctxt
    val ((pt, p), tacis) = Step_Specify.initialise' thy (model, refs)
	  val tac = case tacis of [] => Tactic.Empty_Tac | _ => (#1 o hd) tacis
	  val f = 
           TESTg_form ctxt (pt,p);
"~~~~~ fun TESTg_form , args:"; val (ctxt, ptp) = (ctxt, (pt,p));
    val (form, _, _) =
   ME_Misc.pt_extract ctxt ptp;
"~~~~~ fun pt_extract , args:"; val (ctxt, (pt, (p, p_ as Pbl(*Frm,Pbl*)))) = (ctxt, ptp);
        val ppobj = Ctree.get_obj I pt p
        val f = if Ctree.is_pblobj ppobj then pt_model ppobj p_ else Ctree.get_obj pt_form pt p;

            (*if*) Ctree.is_pblobj ppobj (*then*);
           pt_model ppobj p_ ;
"~~~~~ fun pt_model , args:"; val ((Ctree.PblObj {probl, spec, origin = (_, spec', hdl), ctxt, ...}), Pbl_) =
  (ppobj, p_);
      val (_, pI, _) = Ctree.get_somespec' spec spec';
(*    val where_ = if pI = Problem.id_empty then []*)
               (*if*) pI = Problem.id_empty (*else*);
	          val {where_rls, where_, model, ...} = Problem.from_store ctxt pI
	          val (_, where_) = 
 Pre_Conds.check ctxt where_rls where_
              (model, I_Model.OLD_to_TEST probl);
"~~~~~ fun check , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (model, I_Model.OLD_to_TEST probl));
      val (env_model, (env_subst, env_eval)) = 
           make_environments model_patt i_model;
"~~~~~ fun make_environments , args:"; val (_, []) = (model_patt, i_model);
(*\------------------- step into init_calc -------------------------------------------------//*)
val (p,_,f,nxt,_,pt) = return_init_calc;

(*+*)val PblObj {ctxt, probl, ...} = get_obj I pt [];
(*+*)Proof_Context.theory_of ctxt (*= {Pure, .., Diff_App}*);
(*+*)val Free ("r", Type ("Real.real", [])) = Syntax.read_term ctxt "r"
(*+*)val [] = probl

val return_me_Model_Problem = 
           me nxt p c pt; val Add_Given "Constants [r = 7]" = #4 return_me_Model_Problem;
(*/------------------- step into me_Model_Problem ------------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac as Model_Problem, (p:Pos.pos'), (_:Test_Code.NEW), (pt:Ctree.ctree)) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p
val return_by_tactic = case
      Step.by_tactic tac (pt,p) of
		    ("ok", (_, _, ptp)) => ptp;

(*//------------------ step into by_tactic -------------------------------------------------\\*)
"~~~~~ fun by_tactic , args:"; val (tac, (ptp as (pt, p))) = (tac, (pt,p));
val Applicable.Yes tac' = (*case*)
      Step.check tac (pt, p) (*of*);
(*+*)val Model_Problem' _ = tac';
"~~~~~ fun check , args:"; val (tac, (ctree, pos)) = (tac, (pt, p));
  (*if*) Tactic.for_specify tac (*then*);

Specify_Step.check tac (ctree, pos);
"~~~~~ fun check , args:"; val (Tactic.Model_Problem, (pt, pos as (p, _))) =
  (tac, (ctree, pos));
        val (o_model, pI', ctxt) = case Ctree.get_obj I pt p of
          Ctree.PblObj {origin = (o_model, (_, pI', _), _), ctxt, ...} => (o_model, pI', ctxt)
	      val {model = model_patt, ...} = Problem.from_store (Ctree.get_ctxt pt pos) pI'
	      val pbl = I_Model.init_TEST o_model model_patt;

val return_check =
    Applicable.Yes (Tactic.Model_Problem' (pI', I_Model.TEST_to_OLD pbl, []));
(*\\------------------ step into by_tactic -------------------------------------------------//*)
val (pt, p) = return_by_tactic;

val return_do_next = (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
(*//------------------ step into do_next ---------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val (((ip as (_,p_)):pos'), ((ptp as (pt,p), tacis):Calc.state_pre)) =
  (p, ((pt, e_pos'),[]));
    val pIopt = get_pblID (pt,ip);
    (*if*) ip = ([],Res); (* = false*)
      val _ = (*case*) tacis (*of*);
      val SOME _ = (*case*) pIopt (*of*);

    val ("ok", ([(Add_Given "Constants [r = 7]", _, _)], [], _)) =
      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

    val ("ok", ([(Add_Given "Constants [r = 7]", _, _)], [], _)) =
      Step.specify_do_next (pt, input_pos);
(*///----------------- step into specify_do_next -------------------------------------------\\*)
"~~~~~ fun specify_do_next , args:"; val (ptp as (pt, (p, p_))) = (pt, input_pos);

(*  val (_, (p_', tac)) =*)
val return_find_next_step = (*keep for continuing specify_do_next*)
   Specify.find_next_step ptp;
(*////---------------- step into find_next_step --------------------------------------------\\*)
"~~~~~ fun find_next_step , args:"; val ((pt, pos as (_, p_))) = (ptp);
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos;
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
        (*if*) p_ = Pos.Pbl (*then*);

val return_for_problem as ("dummy", (Pbl, Add_Given "Constants [r = 7]")) =
   Specify.for_problem ctxt oris (o_refs, refs) (pbl, I_Model.OLD_to_TEST met);
(*/////--------------- step into for_problem -----------------------------------------------\\*)
"~~~~~ fun for_problem , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met))
  = (ctxt, oris, (o_refs, refs), (pbl, met));
    val cdI = if dI = ThyC.id_empty then dI' else dI;
    val cpI = if pI = Problem.id_empty then pI' else pI;
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = pbt, where_rls, where_, ...} = Problem.from_store ctxt cpI;
    val {model = mpc, ...} = MethodC.from_store ctxt cmI;

    val return_check =
 Pre_Conds.check ctxt where_rls where_ (pbt, I_Model.OLD_to_TEST pbl);
(*//////-------------- step into check -------------------------------------------------\\*)
"~~~~~ fun check , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (pbt, I_Model.OLD_to_TEST pbl));
      val return_make_environments =
           make_environments model_patt i_model;
(*///// //------------ step into of_max_variant --------------------------------------------\\*)
"~~~~~ fun of_max_variant , args:"; val (model_patt, i_model) =
  (model_patt, i_model);

(*+*)val "[\n(1, [1, 2, 3], false ,#Given, (Inc_TEST Constants [] [__=__, __=__], Position.T)), \n(2, [1, 2, 3], false ,#Find, (Inc_TEST Maximum __, Position.T)), \n(3, [1, 2, 3], false ,#Find, (Inc_TEST AdditionalValues [] [__, __], Position.T)), \n(4, [1, 2, 3], false ,#Relate, (Inc_TEST Extremum (__=__), Position.T)), \n(5, [1, 2], false ,#Relate, (Inc_TEST SideConditions [] [__=__, __=__], Position.T))]"
 = i_model |> I_Model.to_string_TEST ctxt
    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (Model_Def.cnt_corrects) variants_separated
    val sum_variant_s = Model_Def.arrange_args sums_corr (1, all_variants)
(*+*)val [(0, 1), (0, 2), (0, 3)] = sum_variant_s
    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
    val equal_descr_pairs = map (get_equal_descr i_model) model_patt |> flat
(*for building make_env_s -------------------------------------------------------------------\*)
(*!!!*) val ("#Given", (descr, term), pos) =
  Model_Pattern.split_descriptor ctxt ("#Given", @{term "Constants [r = (7::real)]"}, Position.none)
(*!!!*) val patt = equal_descr_pairs |> hd |> #1
(*!!!*)val equal_descr_pairs =
  (patt,
  (1, [1, 2, 3], true, "#Given", (Cor_TEST ((descr, (*!*)TermC.isalist2list(*!*) term)), pos)))
  :: tl equal_descr_pairs
(*for building make_env_s -------------------------------------------------------------------/*)

    val env_model = make_env_model equal_descr_pairs;
(*///// ///----------- step into make_env_model --------------------------------------------\\*)
"~~~~~ fun make_env_model , args:"; val (equal_descr_pairs) = (equal_descr_pairs);

val xxx = (fn ((_, (_, id)), (_, _, _, _, (feedb, _)))
       => (mk_env_model id feedb));
val ((_, (_, id)), (_, _, _, _, (feedb, _))) = nth 4 equal_descr_pairs;
(*\\\\\ \\\----------- step into make_env_model --------------------------------------------//*)
(*||||| ||------------ contine of_max_variant ------------------------------------------------*)

    val equal_givens = filter (fn ((m_field, _), _) => m_field = "#Given") equal_descr_pairs
    val subst_eval_list = make_envs_preconds equal_givens
val return_make_envs_preconds =
           make_envs_preconds equal_givens;
(*///// ///----------- step into make_envs_preconds ----------------------------------------\\*)
"~~~~~ fun make_envs_preconds , args:"; val (equal_givens) = (equal_givens);
val xxx = (fn ((_, (_, id)), (_, _, _, _, (feedb, _))) => discern_feedback id feedb)
;
xxx: (Model_Pattern.single * I_Model.single_TEST) -> ((term * term) * (term * term)) list;
val return_discern_feedback =
           discern_feedback id feedb;
(*nth 1 equal_descr_pairs* )
"~~~~~ fun discern_feedback , args:"; val (id, (Model_Def.Cor_TEST ((descr, ts), _))) = (id, feedb);
( *nth 2 equal_descr_pairs*)
"~~~~~ fun discern_feedback , args:"; val (id, (Model_Def.Inc_TEST ((descr, ts)))) = (id, feedb);

(*nth 1 equal_descr_pairs* )
(*+*)val [((Const ("fixes", typ1), Free ("r", typ2)),
           (Free ("r", typ3), value))] = return_discern_feedback
(*+*)val true = typ1 = typ2
(*+*)val true = typ3 = HOLogic.realT
(*+*)val "7" = UnparseC.term ctxt value
( *nth 2 equal_descr_pairs*)
(*+*)val [] = return_discern_feedback

val return_discern_typ =
           discern_typ id (descr, ts);
"~~~~~ fun discern_typ , args:"; val (id, (descr, ts)) = (id, (descr, ts));
(*nth 1 equal_descr_pairs* )
(*+*)val [((Const ("fixes", typ1), Free ("r", typ2)),
           (Free ("r", typ3), value))] = return_discern_typ
(*+*)val true = typ1 = typ2
(*+*)val true = typ3 = HOLogic.realT
(*+*)val "7" = UnparseC.term ctxt value
( *nth 2 equal_descr_pairs*)
(*+*)val [] = return_discern_typ;
(**)
           switch_type id ts;
"~~~~~ fun switch_type , args:"; val (Const (descr_string, _), ts) = (descr, ts);

(*nth 1 equal_descr_pairs* )
val return_switch_type_TEST = Const (descr_string, ts |> hd |> TermC.lhs |> type_of)

(*+*)val Const ("Input_Descript.Constants", typ) = return_switch_type_TEST
(*+*)val Type ("Real.real", []) = typ
( *nth 2 equal_descr_pairs*)
(*+*)val return_switch_type_TEST = descr
(**)
(*\\\\\ \\\----------- step into make_envs_preconds ----------------------------------------//*)
(*||||| ||------------ contine of_max_variant ------------------------------------------------*)
    val subst_eval_list = make_envs_preconds equal_givens
    val (env_subst, env_eval) = split_list subst_eval_list
val make_environments = (i_model_max, env_model, (env_subst, env_eval)); (*GOON*)
(*\\\\\ \\------------ step into of_max_variant --------------------------------------------//*)
      val (i_model_max, env_model, (env_subst, env_eval)) = make_environments
(*!!!/----- we had a helpful argument for constructing env_model and (env_subst, env_eval)---\*)
      val (i_max_variant, env_model, (env_subst, env_eval)) = (i_model_max, [], ([], []))
(*!!!\----- we had a helpful argument for constructing env_model and (env_subst, env_eval)---/*) 
(*||||| |------------- contine check -----------------------------------------------------*)
      val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)
      val evals = map (eval ctxt where_rls) full_subst
val return_ = (i_model_max, env_subst, env_eval)
(*\\\\\ \------------- step into check -----------------------------------------------------//*)
val (preok, _) = return_check;

(*|||||--------------- contine.. for_problem -------------------------------------------------*)
val false =
    (*if*) dI' = ThyC.id_empty andalso dI = ThyC.id_empty (*else*);
val false =
      (*if*) pI' = Problem.id_empty andalso pI = Problem.id_empty (*else*);
val NONE =
     (*case*) find_first (fn (_, _, _, _, feedb) => I_Model.is_error feedb) pbl (*of*);

(** )val SOME (fd, ct') as ("#Given", "Constants [r = 7]") =( **)
(**)val return_item_to_add as SOME ("#Given", xxx) =(**) (*case*) 
   Specify.item_to_add ctxt oris (I_Model.OLD_to_TEST pbl) (*of*);
(*///// /------------- step into item_to_add -----------------------------------------------\\*)
(*==================== see test/../i_model.sml --- fun item_to_add ---========================*)
(*\\\\\ \------------- step into item_to_add -----------------------------------------------//*)
val SOME (fd, ct') = return_item_to_add
(*+*)val ("#Given", "Constants [r = 7]")  = (fd, ct') (*from NEW item_to_add*)

(*|||||--------------- continue.. for_problem ------------------------------------------------*)
val return_for_problem_step as ("dummy", (Pbl, Add_Given "Constants [r = 7]"))
  = ("dummy", (Pos.Pbl, P_Model.mk_additem fd ct'))
(** )return_for_problem_step = return_for_problem( *..would require equality types*)
(*\\\\\--------------- step into for_problem -----------------------------------------------//*)
val return_find_next_step as ("dummy", (Pbl, Add_Given "Constants [r = 7]"))
  = return_for_problem
(*\\\\---------------- step into find_next_step --------------------------------------------//*)
(*|||----------------- continue.. specify_do_next --------------------------------------------*)
val (_, (p_', tac as Add_Given "Constants [r = 7]")) = return_find_next_step

    val ist_ctxt =  Ctree.get_loc pt (p, p_)
(*+*)val Add_Given "Constants [r = 7]" = tac
val _ =
    (*case*) tac (*of*);

val return_by_tactic_input as ("ok", ([(Add_Given "Constants [r = 7]", _, _)], [], _)) =
Step_Specify.by_tactic_input tac (pt, (p, p_'));
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Add_Given ct), ptp) =
  (tac, (pt, (p, p_')));

   Specify.by_Add_ "#Given" ct ptp;
"~~~~~ fun by_Add_ , args:"; val (m_field, ct ,(pt, pos as (_, p_))) =
  ("#Given", ct, ptp);
    val (met, oris, (_, pI', mI'), pbl, (_, pI, mI), ctxt) = SpecificationC.get_data (pt, pos)
    val (i_model, m_patt) =
       if p_ = Pos.Met then
         (met,
           (if mI = MethodC.id_empty then mI' else mI) |> MethodC.from_store ctxt |> #model)
       else
         (pbl,
           (if pI = Problem.id_empty then pI' else pI) |> Problem.from_store ctxt |> #model);

      (*case*)
   I_Model.check_single ctxt m_field oris i_model m_patt ct (*of*);
"~~~~~ fun check_single , args:"; val (ctxt, m_field, o_model, i_model, m_patt, (str(*, pos*))) =
  (ctxt, m_field, oris, i_model, m_patt, ct);
        val (t as (descriptor $ _)) = Syntax.read_term ctxt str

(*+*)val "Constants [r = 7]" = UnparseC.term ctxt t;

        val SOME m_field' =
          (*case*) Model_Pattern.get_field descriptor m_patt (*of*);
           (*if*) m_field <> m_field' (*else*);

(*+*)val "#Given" = m_field; val "#Given" = m_field'

val ("", ori', all) =
          (*case*) O_Model.contains ctxt m_field o_model t (*of*);

(*+*)val (_, _, _, _, vals) = hd o_model;
(*+*)val "Constants [r = 7]" = UnparseC.term ctxt (@{term Constants} $ (hd vals));
(*+*)if "[\n(1, [\"1\", \"2\", \"3\"], #Given, Constants, [\"[r = 7]\"]), " ^ 
(*+*)    "\n(2, [\"1\", \"2\", \"3\"], #Find, Maximum, [\"A\"]), " ^ 
(*+*)    "\n(3, [\"1\", \"2\", \"3\"], #Find, AdditionalValues, [\"[u]\", \"[v]\"]), " ^ 
(*+*)    "\n(4, [\"1\", \"2\", \"3\"], #Relate, Extremum, [\"A = 2 * u * v - u \<up> 2\"]), " ^ 
(*+*)    "\n(5, [\"1\", \"2\"], #Relate, SideConditions, [\"[(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]\"]), " ^ 
(*+*)    "\n(6, [\"3\"], #Relate, SideConditions, [\"[u / 2 = r * sin \<alpha>]\", \"[2 / v = r * cos \<alpha>]\"]), " ^ 
(*+*)    "\n(7, [\"1\"], #undef, FunctionVariable, [\"a\"]), " ^ 
(*+*)    "\n(8, [\"2\"], #undef, FunctionVariable, [\"b\"]), \n(9, [\"3\"], #undef, FunctionVariable, [\"\<alpha>\"]), " ^ 
(*+*)    "\n(10, [\"1\", \"2\"], #undef, Input_Descript.Domain, [\"{0<..<r}\"]), " ^ 
(*+*)    "\n(11, [\"3\"], #undef, Input_Descript.Domain, [\"{0<..<\<pi> / 2}\"]), " ^ 
(*+*)    "\n(12, [\"1\", \"2\", \"3\"], #undef, ErrorBound, [\"\<epsilon> = 0\"])]"
(*+*)= O_Model.to_string ctxt o_model then () else error "o_model CHANGED";

  (*case*) is_notyet_input ctxt i_model all ori' m_patt (*of*);
"~~~~~ fun is_notyet_input , args:"; val (ctxt, itms, all, (i, v, f, d, ts), pbt) =
  (ctxt, i_model, all, ori', m_patt);
val SOME (_, (_, pid)) =
  (*case*) find_first (eq1 d) pbt (*of*);
(*local*)fun eq3 f d (_, _, _, f', itm_) = f = f' andalso d = (I_Model.descriptor itm_);(*local*)
val SOME (_, _, _, _, itm_) =
    (*case*) find_first (eq3 f d) itms (*of*);
val ts' = inter op = (o_model_values itm_) ts;
            (*if*) subset op = (ts, ts') (*else*);
val return_is_notyet_input = ("", 
           ori_2itm itm_ pid all (i, v, f, d, subtract op = ts' ts));
"~~~~~ fun ori_2itm , args:"; val (itm_, pid, all, (id, vt, fd, d, ts)) =
  (itm_, pid, all, (i, v, f, d, subtract op = ts' ts));
    val ts' = union op = (o_model_values itm_) ts;
    val pval = [Input_Descript.join'''' (d, ts')]
    val complete = if eq_set op = (ts', all) then true else false

(*+*)val "Inc Constants [] , pen2str" = itm_ |> I_Model.feedback_to_string ctxt
(*\\\----------------- step into specify_do_next -------------------------------------------//*)
(*\\------------------ step into do_next ---------------------------------------------------//*)
val ("ok", (ts as (_, _, _) :: _, _, (pt, p))) = return_do_next

(*|------------------- continue with me_Model_Problem ----------------------------------------*)
val tacis as (_::_) =
        (*case*) ts (*of*);
          val (tac, _, _) = last_elem tacis

val return_Model_Problem = (p, [] : NEW, TESTg_form ctxt (pt, p), tac, Celem.Sundef, pt);
(*//------------------ step into TESTg_form ------------------------------------------------\\*)
"~~~~~ fun TESTg_form , args:"; val (ctxt, ptp) = (ctxt, (pt, p));

    val (form, _, _) =
   ME_Misc.pt_extract ctxt ptp;
"~~~~~ fun pt_extract , args:"; val (ctxt, (pt, (p, p_(*Frm,Pbl*)))) = (ctxt, ptp);
        val ppobj = Ctree.get_obj I pt p
        val f = if Ctree.is_pblobj ppobj then pt_model ppobj p_ else Ctree.get_obj pt_form pt p;
          (*if*) Ctree.is_pblobj ppobj (*then*);

           pt_model ppobj p_;
"~~~~~ fun pt_model , args:"; val ((Ctree.PblObj {probl, spec, origin = (_, o_spec, hdl), ctxt, ...}), 
  Pbl(*Frm,Pbl*)) = (ppobj, p_);
      val (_, _, met_id) = References.select_input o_spec spec
      val (allcorr, _) = Pre_Conds.check_internal ctxt (I_Model.OLD_to_TEST probl) (Pos.Met, met_id)
val return_pt_model = Ctree.ModSpec (allcorr, Pos.Pbl, hdl, probl, (*where_*)[(*Problem.from_store in check*)], spec)

(*|------------------- continue with TESTg_form ----------------------------------------------*)
val Ctree.ModSpec (spec as (_, p_, _, gfr, where_, _)) =
    (*case*) form (*of*);
    Test_Out.PpcKF (  (Test_Out.Problem [],
 			P_Model.from (Proof_Context.theory_of ctxt) gfr where_));

   P_Model.from (Proof_Context.theory_of ctxt) gfr where_;
"~~~~~ fun from , args:"; val (thy, itms, where_) = ((Proof_Context.theory_of ctxt), gfr, where_);
    fun coll model [] = model
      | coll model ((_, _, _, field, itm_) :: itms) =
        coll (add_sel_ppc thy field model (item_from_feedback thy itm_)) itms;

 val gfr = coll P_Model.empty itms;
"~~~~~ fun coll , args:"; val (model, ((aaa, bbb_,ccc_, field, itm_) :: itms))
  = (P_Model.empty, itms);

(*+*)val 4 = length itms;
(*+*)val itm = nth 1 itms;

           coll P_Model.empty [itm];
"~~~~~ fun coll , iterate:"; val (model, ((aaa, bbb_,ccc_, field, itm_) :: []))
  = (P_Model.empty, [itm]);

          (add_sel_ppc thy field model (item_from_feedback thy itm_));
"~~~~~ fun add_sel_ppc , args:"; val ((_: theory), sel, {Given = gi, Where = wh, Find = fi, With = wi, Relate = re}, x )
  = (thy, field, model, (item_from_feedback thy itm_));

   P_Model.item_from_feedback thy itm_;
"~~~~~ fun item_from_feedback , args:"; val (thy, (I_Model.Inc ((d, ts), _))) = (thy, itm_);
   P_Model.Incompl (UnparseC.term_in_thy thy (Input_Descript.join (d, ts)));
(*\\------------------ step into TESTg_form ------------------------------------------------//*)
(*\------------------- step into me_Model_Problem ------------------------------------------//*)
val (p, _, f, nxt, _, pt) = return_me_Model_Problem

(*+++*)val {probl, ...} = Calc.specify_data (pt, pos);
(*+++*)val "[\n(1 ,[1, 2, 3] ,false ,#Given ,Inc Constants [] , pen2str), \n(2 ,[1, 2, 3] ,false ,#Find ,Inc Maximum , pen2str), \n(3 ,[1, 2, 3] ,false ,#Find ,Inc AdditionalValues [] , pen2str), \n(4 ,[1, 2, 3] ,false ,#Relate ,Inc Extremum , pen2str), \n(5 ,[1, 2] ,false ,#Relate ,Inc SideConditions [] , pen2str)]"
 = probl |> I_Model.to_string ctxt
(*-------------------- contine me's ----------------------------------------------------------*)
val return_me_add_find_Constants = me nxt p c pt;
                                      val Add_Find "Maximum A" = #4 return_me_add_find_Constants;
(*/------------------- step into me_add_find_Constants -------------------------------------\\*)
(*==================== done in "Minisubpbl/150a-add-given-Maximum.sml" subsequently =======================*)
