(*  Title:      ~~test/../ProgLang/calculate.thy
    Author:     Walther Neuper
*)

theory calculate
imports Isac.Build_Thydata
begin

text \<open>
  *setup* for a test only; thus it is not contained in src/../Knowledge/*.
  *setup* Know_Store.add_pbls / add_mets is impossible in *.sml files, thus this thy.
  The respective test/../evaluate.sml is called in Test_Isac.thy.
\<close> ML \<open>
(*/----- local in struct Problem -------------\*)
val drop_pos_model = (fn (a, b, _) => (a, b))
val drop_pos_where_ = (fn (b, _) => b)
(*\----- local in struct Problem -------------/*)
val thy = @{theory "Test"}
            val arg_1 = Problem.prep_store thy "pbl_ttest" [] Problem.id_empty
              ([], [], NONE) (["test"], [], Rule_Set.empty)

val model_input = [("#Given", [("realTestGiven t_t", Position.none)]),
                   ("#Find", [("realTestFind s_s", Position.none)])]
(* cp from problem.sml, Outer_Syntax.command \<^command_keyword>\<open>problem\<close> *)
            val ctxt = Proof_Context.init_global thy
            val (model, where_) = Model_Pattern.parse_pos ctxt model_input
            val (model', where_') = (map drop_pos_model model, map drop_pos_where_ where_)
            val arg_2 = Problem.prep_store thy "pbl_ttest_calc" [] Problem.id_empty
              (model', where_', NONE)
              (["calculate", "test"], [["Test", "test_calculate"]], Rule_Set.empty)
\<close> 
setup \<open>Know_Store.add_pbls @{context} [arg_1, arg_2]\<close>


partial_function (tailrec) calc_test :: "real \<Rightarrow> real"
  where
"calc_test t_t =
  (Repeat
    ((Try (Repeat (Calculate ''PLUS''))) #>
     (Try (Repeat (Calculate ''TIMES''))) #>
     (Try (Repeat (Calculate ''DIVIDE''))) #>
     (Try (Repeat (Calculate ''POWER''))))) t_t"
ML \<open>
val model_input = [("#Given", [("realTestGiven t_t", Position.none)]),
                   ("#Find", [("realTestFind s_s", Position.none)])]
(* cp from method.sml, Outer_Syntax.command \<^command_keyword>\<open>method\<close> *)
          val (model, where_) = Model_Pattern.parse_pos ctxt model_input
          val (model', where_') = (map drop_pos_model model, map drop_pos_where_ where_)
          val ml_input =
            {rew_ord = "sqrt_right", rls'= tval_rls, prog_rls = Rule_Set.empty, where_rls = Rule_Set.empty,
            calc = [("PLUS", (\<^const_name>\<open>plus\<close>, Calc_Binop.numeric "#add_")),
                    ("TIMES", (\<^const_name>\<open>times\<close>, Calc_Binop.numeric "#mult_")),
                    ("DIVIDE", (\<^const_name>\<open>divide\<close>, Prog_Expr.eval_cancel "#divide_")),
                    ("POWER", (\<^const_name>\<open>realpow\<close>, Calc_Binop.numeric "#power_"))],
            errpats = [], rew_rls = Rule_Set.empty} : MethodC.ml_input
          val thm = @{thm calc_test.simps}
          val arg = MethodC.prep_store thy "met_testcal" [] Problem.id_empty
            (["Test", "test_calculate"], model', where_', ml_input, thm)
\<close> 
setup \<open>Know_Store.add_mets @{context} [arg]
\<close>

ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>
end
