theory Test_Some
  imports "Isac.Build_Isac" "$ISABELLE_ISAC_TEST/Tools/isac/ADDTESTS/accumulate-val/Lucas_Interpreter"
begin 

ML \<open>open ML_System\<close>
ML \<open>
  open Kernel;
  open Math_Engine;
  open Test_Code;              Test_Code.init_calc @{context};
  open LItool;                 arguments_from_model;
  open Sub_Problem;
  open Fetch_Tacs;
  open Step
  open Env;
  open LI;                     scan_dn;
  open Istate;
  open Error_Pattern;
  open Error_Pattern_Def;
  open Specification;
  open Ctree;                  append_problem;
  open Pos;
  open Program;
  open Prog_Tac;
  open Tactical;
  open Prog_Expr;
  open Auto_Prog;              rule2stac;
  open Input_Descript;
  open Specify;
  open Specify;
  open Step_Specify;
  open Step_Solve;
  open Step;
  open Solve;                  (* NONE *)
  open ContextC;               transfer_asms_from_to;
  open Tactic;                 (* NONE *)
  open I_Model;
  open O_Model;
  open P_Model;                (* NONE *)
  open Rewrite;
  open Eval;                   get_pair;
  open TermC;
  open Rule;
  open Rule_Set;               Sequence;
  open Eval_Def
  open ThyC
  open ThmC_Def
  open ThmC
  open Rewrite_Ord
  open UnparseC;

  Know_Store.set_ref_last_thy @{theory};
  (*otherwise ERRORs in pbl-met-hierarchy.sml, refine.sml, evaluate.sml*)
\<close>

section \<open>code for copy & paste ===============================================================\<close>
text \<open>
  declare [[show_types]] 
  declare [[show_sorts]]
  find_theorems "?a <= ?a"
  
  print_theorems
  print_facts
  print_statement ""
  print_theory
  ML_command \<open>Pretty.writeln prt\<close>
  declare [[ML_print_depth = 999]]
  declare [[ML_exception_trace]]
\<close>
ML \<open>
(*WN230827 adaptation too time consuming* )
( *WN230827 adaptation too time consuming*)
\<close> ML \<open>
"~~~~~ fun xxx , args:"; val () = ();
"~~~~~ and xxx , args:"; val () = ();
"~~~~~ from fun xxx \<longrightarrow>fun yyy \<longrightarrow>fun zzz , return:"; val () = ();
"~~~~~ continue fun xxx"; val () = ();
(*if*) (*then*); (*else*); (*andalso*)  (*case*) (*of*);  (*return value*); (*in*) (*end*);
"xx"
^ "xxx"   (*+*) (*+++*) (*keep for continuing YYYYY*) (*isa*) (*isa2*) (**)
\<close> ML \<open> (*//----------- build fun XXXXX -----------------------------------------------------\\*)
(*//------------------ build fun XXXXX -----------------------------------------------------\\*)
(*\\------------------ build fun XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- build fun XXXXX -----------------------------------------------------//*)

val return_XXXXX = "XXXXX"
\<close> ML \<open> (*//----------- step into XXXXX -----------------------------------------------------\\*)
(*//------------------ step into XXXXX -----------------------------------------------------\\*)
\<close> ML \<open> (*||----------- contine-- XXXXX -------------------------------------------------------*)
(*||------------------ contine-- XXXXX -------------------------------------------------------*)
(*\\------------------ step into XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into XXXXX -----------------------------------------------------//*)
val "XXXXX" = return_XXXXX;

(* final test ... ----------------------------------------------------------------------------*)

\<close> ML \<open> (*//----------- inserted hidden code ------------------------------------------------\\*)
(*//------------------ inserted hidden code ------------------------------------------------\\*)
(*\\------------------ inserted hidden code ------------------------------------------------//*)
\<close> ML \<open> (*\\----------- inserted hidden code ------------------------------------------------//*)

\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close>

(**)ML_file "MathEngine/step.sml" (** )check file with test under repair below( **)
section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
"--------- embed fun Step.inconsistent -------------------";
"--------- embed fun Step.inconsistent -------------------";
"--------- embed fun Step.inconsistent -------------------";
States.reset (); 
CalcTree @{context}
[(["functionTerm (x ^ 2 + sin (x ^ 4))", "differentiateFor x", "derivative f_f'"], 
  ("Isac_Knowledge", ["derivative_of", "function"], ["diff", "differentiate_on_R"]))];
Iterator 1;
moveActiveRoot 1;
\<close> ML \<open>
     val ppp = States.get_pos 1 1
\<close> ML \<open>
     val previous_pos as ([], Pbl) = ppp(*+*)
     val previous_calc = States.get_calc 1(*+*)
\<close> ML \<open>

           autoCalculate 1 CompleteCalcHead;
\<close> ML \<open> (*/------------ step into autoCalculate \<longrightarrow> ([], Met) -------------------------------\\*)
(*/------------------- step into autoCalculate \<longrightarrow> ([], Met) -------------------------------\\*)
"~~~~~ fun autoCalculate , args:"; val (cI, auto) = (1, CompleteCalcHead);
\<close> ML \<open>
     val pold as ([], Pbl) = previous_pos  (*..States.get_pos cI 1  ..AFTER RUNNING autoCalculate !!!*)
     val calc = previous_calc (*..States.get_pos cI 1  ..AFTER RUNNING autoCalculate !!!*)
\<close> ML \<open>
    (*case*)
Math_Engine.autocalc [] pold calc auto (*of*);
"~~~~~~ fun autocalc , args:"; val (c, (pos as (_, p_)), ((pt, _), _(*tacis could help 1x in solve*)), auto) =
  ([], pold, calc, auto);
\<close> ML \<open>
(*+*)val false = Solve.autoord auto > 3
(*+*)val true = Ctree.just_created (pt, pos)
val false =
    (*if*) Solve.autoord auto > 3 andalso Ctree.just_created (pt, pos) (*else*);
\<close> ML \<open>

val true =
      (*if*) member op = [Pos.Pbl, Pos.Met] p_ (*then*);
\<close> ML \<open>
(*isa*)  val false =(**)
(*isa2* )val true =( **)
        (*if*) not (
SpecificationC.is_complete (pt, pos)) (*else*);
\<close> ML \<open>
(*isa*)
"~~~~~~~~~ fun is_complete , args:"; val (pt, pos as (p, p_)) = (pt, pos);
      val (itms, oris, probl, o_spec, spec, ctxt) = case get_obj I pt p of
         PblObj {meth = itms, origin = (oris, o_spec, _), probl, spec, ctxt, ...}
         => (itms, oris, probl, o_spec, spec, ctxt)
      | _ => raise ERROR "SpecificationC.is_complete only with PblObj"
      val (_, pbl_id, met_id) = References.select_input o_spec spec
\<close> ML \<open>
val return_is_complete = I_Model.s_are_complete ctxt oris
        (I_Model.OLD_to_TEST probl, I_Model.OLD_to_TEST itms) (pbl_id, met_id)
\<close> ML \<open>(*GOON*)
(*+*)val [] = probl
(*+*)val [] = itms
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
val true =
   		    (*if*) not (References.are_complete (pt, pos)) (*then*);
\<close> ML \<open>
             val ptp = References.complete (pt, pos)
\<close> ML \<open>
val true =
   		        (*if*) Solve.autoord auto = 3 (*then*);
\<close> ML \<open>
val return_autocalc = ("ok", c, ptp)
\<close> ML \<open>
(*+isa*)val (_, ([], Pbl)) = ptp(*+*)
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
(*+isa*)val ([], Pbl) = pold(*+*)
(*+isa2* )val ([], Pbl) = pold( *+*)
\<close> ML \<open>
(*\------------------- step into autoCalculate \<longrightarrow> ([], Met) -------------------------------//*)
\<close> ML \<open> (*\------------ step into autoCalculate \<longrightarrow> ([], Met) -------------------------------//*)

autoCalculate 1 (Steps 1);
autoCalculate 1 (Steps 1);(*([1], Res), d_d x (x \<up> 2) + d_d x (sin (x \<up> 4))*)
;
         @{term "d_d x (x \<up> 2) + cos (4 * x \<up> 3)" }
;
\<close> ML \<open>
           appendFormula 1 "d_d x (x \<up> 2) + cos (4 * x \<up> 3)"; (*ERROR with chain rule*)
(*ERROR 
CAS_Cmd "(+)" missing in theory "Test_Isac_Short" (and ancestors). 
val it = <SYSERROR><CALCID>1</CALCID><ERROR>error in kernel 17: lev_back&apos;: called by ([],_)</ERROR></SYSERROR>: XML.tree*)
(*/------------------- step into appendFormula ---------------------------------------------\\*)
"~~~~~ fun appendFormula , args:"; val (cI, ifo) = (1, "d_d x (x \<up> 2) + cos (4 * x \<up> 3)");
\<close> ML \<open>
           appendFormula' cI ifo;
(*ERROR 
CAS_Cmd "(+)" missing in theory "Test_Isac_Short" (and ancestors). 
val it = <SYSERROR><CALCID>1</CALCID><ERROR>error in kernel 17: lev_back&apos;: called by ([],_)</ERROR></SYSERROR>: XML.tree*)
"~~~~~ fun appendFormula' , args:"; val (cI, ifo) = (cI, ifo);
\<close> ML \<open>
    val cs = States.get_calc cI
    val pos = States.get_pos cI 1
\<close> ML \<open>
(*val ("ok", (_, _, ptp)) = (*case*)*)
val return_do_next =
      Step.do_next pos cs (*of*);
(*+isa*)val ([], Pbl) = pos(*+*)
(*+isa2* )val ([1], Res) = pos( *+*)
\<close> ML \<open>
\<close> ML \<open> (*//----------- step into do_next ---------------------------------------------------\\*)
(*//------------------ step into do_next ---------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (pos, cs);
\<close> ML \<open>
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
\<close> ML \<open>
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);
\<close> ML \<open>
           switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
\<close> ML \<open>
(*+isa*)val true =(*+*)
(*+isa2* )val false =( *+*)
      (*if*) Pos.on_specification ([(*or some other int list*)], state_pos) (*then*);
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open> (*||----------- contine-- do_next -----------------------------------------------------*)
(*||------------------ contine-- do_next -----------------------------------------------------*)
(*\\------------------ step into do_next ---------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into do_next ---------------------------------------------------//*)
val ("ok", (_, _, ptp)) = return_do_next;
"~~~~~ fun do_next , args:"; val () = ();
\<close> text \<open>
        (*case*)
Step_Solve.by_term ptp (encode ifo) (*of*);
(*ERROR
CAS_Cmd "(+)" missing in theory "Test_Isac_Short" (and ancestors). 
lev_back': called by ([],_)*)
\<close> ML \<open>
"~~~~~ fun by_term , args:"; val ((pt, pos as (p, _)), istr) = (ptp, (encode ifo));
\<close> ML \<open>
    val f_in = Syntax.read_term (Ctree.get_ctxt pt pos) istr
      handle ERROR msg => error (msg (*^ Position.here pp*))
    val pos_pred = lev_back(*'*) pos
	  val f_pred = Ctree.get_curr_formula (pt, pos_pred);
	  val f_succ = Ctree.get_curr_formula (pt, pos);
\<close> ML \<open>
    (*if*) f_succ = f_in (*else*);
\<close> ML \<open>
val NONE =
      (*case*) CAS_Cmd.input f_in (*of*);
(*ERROR CAS_Cmd "(+)" missing in theory "Test_Isac_Short" (and ancestors). *)
\<close> text \<open>
        (*case*)
        LI.locate_input_term (pt, pos) f_in (*of*);
(*ERROR lev_back': called by ([],_)*)
\<close> ML \<open>
"~~~~~ fun locate_input_term , args:"; val ((pt, pos), tm) = ((pt, pos), f_in);
\<close> text \<open>
   		val pos_pred = Pos.lev_back' pos (*f_pred ---"step pos cs"---> f_succ in appendFormula*)
(*ERROR lev_back': called by ([],_)*)
\<close> ML \<open>
(*+isa*)val ([], Pbl) = pos(*+*)
(*+isa2* )val ([2], Res) = pos( *+*)
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>

\<close> text \<open> (*ERROR lev_back': called by ([],_)*)
  (*case*)
Step_Solve.by_term ptp (encode ifo) (*of*); (*WAS ERROR: Inner syntax error \n Failed to parse term*)
(*\------------------- step into appendFormula ---------------------------------------------//*)

(* the check for errpat is maximally liberal (whole term modulo "rew_rls" from "type met"),
  would recognize "cos (4 * x ^ (4 - 1)) + 2 * x" as well.
  results in <CALCMESSAGE> error pattern #chain-rule-diff-both# </CALCMESSAGE>
  instead of <CALCMESSAGE> no derivation found </CALCMESSAGE> *)
(*========== inhibit exn WN1130621 Isabelle2012-->13 !thehier! ====================
*)
\<close> ML \<open>
findFillpatterns 1 "chain-rule-diff-both";
(*<CALCMESSAGE> fill patterns #fill-d_d-arg#d_d x (x \<up> 2) + d_d x (sin (x \<up> 4)) =
  d_d x (x \<up> 2) + cos (x \<up> 4) * d_d x ?_dummy_1#fill-both-args#...#...#... *)
\<close> ML \<open>
"~~~~~ fun requestFillformula, args:"; val (cI, (errpatID, fillpatID)) =
  (1, ("chain-rule-diff-both", "fill-both-args"));
    val ((pt, _), _) = States.get_calc cI
		    val pos as (p, _) = States.get_pos cI 1;
\<close> text \<open> (*ERROR Step.inconsistent changed 1*)
    val fillforms = Error_Pattern.find_fill_patterns (pt, pos) errpatID;

if pos = ([1], Res) then () else error "Step.inconsistent changed 1";

 val (_, fillform, thm, sube_opt) :: _ = filter ((curry op = fillpatID) o 
        (#1: (fillpatID * term * thm * (subs option) -> fillpatID))) fillforms;

"~~~~~ fun Step.inconsistent, args:";
  val ((subs_opt, thm'), f', (is, ctxt), pos, pt) =
    ((sube_opt, thm'_of_thm thm), fillform, (get_loc pt pos), pos, pt);

    val f = get_curr_formula (pt, pos);
    val pos' as (p', _) = (lev_on p, Res);

if pos = ([1], Res) then () else error "Step.inconsistent changed 2a";
if UnparseC.term @ {context} f = "d_d x (x \<up> 2) + d_d x (sin (x \<up> 4))"
  then () else error "Step.inconsistent changed 2b";

    val (pt,c) = 
      case subs_opt of
        NONE => cappend_atomic pt p' (is, ContextC.insert_assumptions [] ctxt) f
          (Rewrite thm') (f', []) Inconsistent
      | SOME subs => cappend_atomic pt p' (is, ContextC.insert_assumptions [] ctxt) f
          (Rewrite_Inst (subs, thm')) (f', []) Inconsistent
    val pt = update_branch pt p' TransitiveB;

if get_obj g_tac pt p' = Rewrite_Inst (["(''bdv'', x)"], ("diff_sin_chain", ""))
  andalso pos = ([1], Res) andalso pos' = ([2], Res) andalso p' = [2]
then () else error "Step.inconsistent changed 3";

"~~~~~ to requestFillformula return val:"; val (pt, pos') = (pt, pos');
(*val (pt, pos') = Step.inconsistent (sube_opt, thm'_of_thm thm)
            (fillform, []) (get_loc pt pos) pos' pt*)
States.upd_calc cI ((pt, pos'), []); States.upd_ipos cI 1 pos';

"~~~~~ final check:";
val ((pt, _),_) = States.get_calc 1;
val p = States.get_pos 1 1;
val (Form f, _, asms) = ME_Misc.pt_extract (pt, p);
if p = ([2], Res) andalso 
  get_obj g_tac pt (fst p) = Rewrite_Inst (["(''bdv'', x)"], ("diff_sin_chain", "")) andalso
  UnparseC.term @ {context} f =
  "d_d x (x \<up> 2) + d_d x (sin (x \<up> 4)) =\nd_d x (x \<up> 2) + cos ?u * d_d x ?_dummy_2"
  (*WAS with old findFillpatterns:
  "d_d x (x \<up> 2) + d_d x (sin (x \<up> 4)) =\nd_d x (x \<up> 2) + cos ?_dummy_2 * d_d x ?_dummy_3"
  WN120731 replaced 
  "d_d x (x \<up> 2) + d_d x (sin (x \<up> 4)) =\nd_d x (x \<up> 2) + cos ?u * d_d x ?_dummy_2"
  WN120804 replaced
  "d_d x (x \<up> 2) + d_d x (sin (x \<up> 4)) =\nd_d x (x \<up> 2) + cos ?_dummy_1 * d_d x ?_dummy_2"*)
then () else error "Step.inconsistent changed: fill-formula?";

Test_Tool.show_pt pt; (*ATTENTION: omits the last step, if pt is incomplete, ([2], Res) EXISTS !*)
============ inhibit exn WN1130621 Isabelle2012-->13 !thehier! ==================*)


\<close> ML \<open>

\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====   ===========================================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close>

end
